searchData={"items":[{"type":"task","title":"mix outerfaces.copy","doc":"Copies files from the source_dir to the target_dir.\nFirst clears the target directory.","ref":"Mix.Tasks.Outerfaces.Copy.html"},{"type":"function","title":"Mix.Tasks.Outerfaces.Copy.copy_files/2","doc":"","ref":"Mix.Tasks.Outerfaces.Copy.html#copy_files/2"},{"type":"function","title":"Mix.Tasks.Outerfaces.Copy.copy_files/3","doc":"","ref":"Mix.Tasks.Outerfaces.Copy.html#copy_files/3"},{"type":"function","title":"Mix.Tasks.Outerfaces.Copy.run/1","doc":"Copies files from the source_dir to the target_dir.\nFirst clears the target directory.","ref":"Mix.Tasks.Outerfaces.Copy.html#run/1"},{"type":"task","title":"mix outerfaces.dist","doc":"Copies outerfaces projects to the priv/static/outerfaces directory","ref":"Mix.Tasks.Outerfaces.Dist.html"},{"type":"function","title":"Mix.Tasks.Outerfaces.Dist.run/1","doc":"Copies all outerfaces projects to the priv/static/outerfaces directory","ref":"Mix.Tasks.Outerfaces.Dist.html#run/1"},{"type":"module","title":"Outerfaces","doc":"Outerfaces - Portable, Dynamic Web Applications.\n\nThis 'Outerfaces' core Elixir library contains helper modules for working with\n\"client-side\" applications that live within a Phoenix web application,\nand are served dynamically with the application at runtime by individual dedicated endpoints.","ref":"Outerfaces.html"},{"type":"module","title":"What is Outerfaces? - Outerfaces","doc":"Outerfaces is an experimental web framework that is built on top of Elixir + Phoenix.\n\nIt is designed to streamline web application development by integrating front-end and back-end workflows within a single codebase, while maintaining their separation.\n\nThis core library provides the necessary tools to integrate Outerfaces with your Phoenix application. These modules here are only starting points, and are expected to be extended and customized to fit your needs.\n\nOuterfaces is still a hobby project and in early development, and as such is not recommended for production use.\n\nThere are accompanying libraries intended to be used with Outerfaces, such as a dependency-free Javascript Library for building functional front-end web applications using modern Javascript, and a quick-start examples project for quickly scaffolding a new client-side projects. These libraries are not (yet?) available publicly.","ref":"Outerfaces.html#module-what-is-outerfaces"},{"type":"module","title":"Quick Start - Outerfaces","doc":"","ref":"Outerfaces.html#module-quick-start"},{"type":"module","title":"Folder Structure - Outerfaces","doc":"Place the `/outerfaces/projects/` directory next to the `/lib/` directory in your Phoenix app.\n```\nconfig/\ndeps/\nlib/\n  ├── my_app/\n  ├── my_app_web/\nouterfaces/\n  └── projects/\n      ├── hello_world/\n      │   └── index.html\n      ├── hello_moon/\n      │   └── index.html\n      └── hello_stars/\n          └── index.html\npriv/\ntest/\n```","ref":"Outerfaces.html#module-folder-structure"},{"type":"module","title":"Application Configuration - Outerfaces","doc":"The following simplified example shows a quick way to add dynamic endpoints for each of the projects in the `/outerfaces/projects/` directory:\n\nAdd to your application's supervision tree in `application.ex`:\n\n```elixir\nchildren = [\n  MyAppWeb.Endpoint,\n  Outerfaces.Endpoints.DefaultInitializer.supervisor(\n    :my_app,\n    MyAppWeb,\n    [\"hello_world\", \"hello_moon\", \"hello_stars\"],\n    []\n  )\n]\n```","ref":"Outerfaces.html#module-application-configuration"},{"type":"module","title":"Advanced Configuration - Outerfaces","doc":"Outerfaces application configuration, including specification for which projects to load, http configuration to use for the dynamic endpoints, etc should be placed in your application's configuration.\n\nAlternatively, you can implement your own version of the `Outerfaces.Endpoints.DefaultInitializer` module to customize the initialization process, along with the `Outerfaces.Endpoints.DynamicLoader` module to customize the dynamic loading process.\n\nSee the default implementations for exampes of customization:\n\n- [(Example) Default Dynamic Loader](https://github.com/outerfaces/outerfaces_ex_core/blob/main/lib/endpoints/dynamic_loader/default_dynamic_loader.ex)\n\n- [(Example) Default Initializer](https://github.com/outerfaces/outerfaces_ex_core/blob/main/lib/endpoints/default_initializer.ex)\n\n## \"Building\" Static Files\nRun the following to copy all Outerfaces project files into `priv/`:\n```bash\nmix outerfaces.dist\n```","ref":"Outerfaces.html#module-advanced-configuration"},{"type":"module","title":"Examples - Outerfaces","doc":"See example Phoenix application [here](https://github.com/outerfaces/outerfaces_examples).","ref":"Outerfaces.html#module-examples"},{"type":"module","title":"Outerfaces.Endpoints.DefaultInitializer","doc":"Example Outerfaces endpoints application initializer","ref":"Outerfaces.Endpoints.DefaultInitializer.html"},{"type":"function","title":"Outerfaces.Endpoints.DefaultInitializer.show_deprecation_warning/0","doc":"","ref":"Outerfaces.Endpoints.DefaultInitializer.html#show_deprecation_warning/0"},{"type":"function","title":"Outerfaces.Endpoints.DefaultInitializer.supervisor/4","doc":"","ref":"Outerfaces.Endpoints.DefaultInitializer.html#supervisor/4"},{"type":"module","title":"Outerfaces.Endpoints.DynamicLoader.DefaultDynamicLoader","doc":"Default example of a custom endpoint loader for Outerfaces projects.","ref":"Outerfaces.Endpoints.DynamicLoader.DefaultDynamicLoader.html"},{"type":"function","title":"Outerfaces.Endpoints.DynamicLoader.DefaultDynamicLoader.show_deprecation_warning/0","doc":"","ref":"Outerfaces.Endpoints.DynamicLoader.DefaultDynamicLoader.html#show_deprecation_warning/0"},{"type":"behaviour","title":"Outerfaces.Endpoints.DynamicLoader.DynamicLoaderBehavior","doc":"A behaviour module that outlines the required callbacks for DynamicLoader.","ref":"Outerfaces.Endpoints.DynamicLoader.DynamicLoaderBehavior.html"},{"type":"callback","title":"Outerfaces.Endpoints.DynamicLoader.DynamicLoaderBehavior.create_dynamic_endpoint_spec/4","doc":"Creates the endpoint module for a project with a given outerfaces_project_name, app slug, and (dynamically generated) endpoint_module.\nAdds the built endpoint module to the given app web module, and adds the endpoint config to app config for the given app slug.","ref":"Outerfaces.Endpoints.DynamicLoader.DynamicLoaderBehavior.html#c:create_dynamic_endpoint_spec/4"},{"type":"callback","title":"Outerfaces.Endpoints.DynamicLoader.DynamicLoaderBehavior.dynamic_port/2","doc":"Returns a dynamic port number using the base port and index of the project * ports per project","ref":"Outerfaces.Endpoints.DynamicLoader.DynamicLoaderBehavior.html#c:dynamic_port/2"},{"type":"callback","title":"Outerfaces.Endpoints.DynamicLoader.DynamicLoaderBehavior.endpoint_config_for_project/3","doc":"Returns the endpoint config for the given arguments","ref":"Outerfaces.Endpoints.DynamicLoader.DynamicLoaderBehavior.html#c:endpoint_config_for_project/3"},{"type":"callback","title":"Outerfaces.Endpoints.DynamicLoader.DynamicLoaderBehavior.hydrate_endpoint_modules/4","doc":"Compiles and returns a list of the instantiated endpoint modules for each project.","ref":"Outerfaces.Endpoints.DynamicLoader.DynamicLoaderBehavior.html#c:hydrate_endpoint_modules/4"},{"type":"callback","title":"Outerfaces.Endpoints.DynamicLoader.DynamicLoaderBehavior.prepare_endpoint_module/4","doc":"Builds an endpoint module for a project for the given arguments.\n\nThis allows developers to define custom endpoint plug pipelines for each project's endpoint.","ref":"Outerfaces.Endpoints.DynamicLoader.DynamicLoaderBehavior.html#c:prepare_endpoint_module/4"},{"type":"callback","title":"Outerfaces.Endpoints.DynamicLoader.DynamicLoaderBehavior.prepare_endpoint_modules/4","doc":"Builds modules to define endpoints for each outerfaces project.","ref":"Outerfaces.Endpoints.DynamicLoader.DynamicLoaderBehavior.html#c:prepare_endpoint_modules/4"},{"type":"module","title":"Outerfaces.Plugs.ContentSecurityPolicies.DefaultCSP","doc":"A default example plug for setting Content Security Policy headers on responses.","ref":"Outerfaces.Plugs.ContentSecurityPolicies.DefaultCSP.html"},{"type":"function","title":"Outerfaces.Plugs.ContentSecurityPolicies.DefaultCSP.call/2","doc":"","ref":"Outerfaces.Plugs.ContentSecurityPolicies.DefaultCSP.html#call/2"},{"type":"function","title":"Outerfaces.Plugs.ContentSecurityPolicies.DefaultCSP.init/1","doc":"","ref":"Outerfaces.Plugs.ContentSecurityPolicies.DefaultCSP.html#init/1"},{"type":"module","title":"Outerfaces.Plugs.ServeIndex.DefaultServeIndex","doc":"A default example plug to handle both static asset requests and index.html fallback.","ref":"Outerfaces.Plugs.ServeIndex.DefaultServeIndex.html"},{"type":"behaviour","title":"Outerfaces.Plugs.ServeIndex.ServeIndexBehavior","doc":"A behavior module that defines the required callbacks for the ServeIndex plug.\nThis module specifies the contract for ServeIndex implementations.","ref":"Outerfaces.Plugs.ServeIndex.ServeIndexBehavior.html"},{"type":"callback","title":"Outerfaces.Plugs.ServeIndex.ServeIndexBehavior.call/2","doc":"","ref":"Outerfaces.Plugs.ServeIndex.ServeIndexBehavior.html#c:call/2"},{"type":"type","title":"Outerfaces.Plugs.ServeIndex.ServeIndexBehavior.call_params/0","doc":"","ref":"Outerfaces.Plugs.ServeIndex.ServeIndexBehavior.html#t:call_params/0"},{"type":"type","title":"Outerfaces.Plugs.ServeIndex.ServeIndexBehavior.conn/0","doc":"","ref":"Outerfaces.Plugs.ServeIndex.ServeIndexBehavior.html#t:conn/0"},{"type":"callback","title":"Outerfaces.Plugs.ServeIndex.ServeIndexBehavior.default_static_asset_patterns/0","doc":"","ref":"Outerfaces.Plugs.ServeIndex.ServeIndexBehavior.html#c:default_static_asset_patterns/0"},{"type":"callback","title":"Outerfaces.Plugs.ServeIndex.ServeIndexBehavior.init/1","doc":"","ref":"Outerfaces.Plugs.ServeIndex.ServeIndexBehavior.html#c:init/1"},{"type":"callback","title":"Outerfaces.Plugs.ServeIndex.ServeIndexBehavior.serve_index_html/2","doc":"","ref":"Outerfaces.Plugs.ServeIndex.ServeIndexBehavior.html#c:serve_index_html/2"},{"type":"callback","title":"Outerfaces.Plugs.ServeIndex.ServeIndexBehavior.serve_static_asset/3","doc":"","ref":"Outerfaces.Plugs.ServeIndex.ServeIndexBehavior.html#c:serve_static_asset/3"},{"type":"callback","title":"Outerfaces.Plugs.ServeIndex.ServeIndexBehavior.static_asset_request?/2","doc":"","ref":"Outerfaces.Plugs.ServeIndex.ServeIndexBehavior.html#c:static_asset_request?/2"},{"type":"module","title":"Outerfaces.Supervisors.OuterfacesSupervisor","doc":"A supervisor for all Outerfaces project endpoints.\n\nThis module also has the functions for stopping and restarting endpoints.","ref":"Outerfaces.Supervisors.OuterfacesSupervisor.html"},{"type":"function","title":"Outerfaces.Supervisors.OuterfacesSupervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Outerfaces.Supervisors.OuterfacesSupervisor.html#child_spec/1"},{"type":"function","title":"Outerfaces.Supervisors.OuterfacesSupervisor.restart_endpoint/1","doc":"","ref":"Outerfaces.Supervisors.OuterfacesSupervisor.html#restart_endpoint/1"},{"type":"function","title":"Outerfaces.Supervisors.OuterfacesSupervisor.start_link/1","doc":"","ref":"Outerfaces.Supervisors.OuterfacesSupervisor.html#start_link/1"},{"type":"function","title":"Outerfaces.Supervisors.OuterfacesSupervisor.stop_endpoint/1","doc":"","ref":"Outerfaces.Supervisors.OuterfacesSupervisor.html#stop_endpoint/1"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.1"}}